[include version_include.man]
[manpage_begin {commandlist} n [vset version]]
[moddesc {NaviServer Built-in Commands}]

[titledesc {NaviServer Commands}]

[description]
List of all currently available NaviServer commands.

[section {ADP Commands}]
[list_begin definitions]

[call [cmd ns_adp_register]]
[list_begin definitions]
[call [cmd ns_adp_registeradp]]
[call [cmd ns_adp_registerproc]]
[call [cmd ns_adp_registerscript]]
[list_end]

[def "ADP configuration"] 
[list_begin definitions]
[call [cmd ns_adp_ctl]]
[list_end]

[def "ADP exception management"] 
[list_begin definitions]
[call [cmd ns_adp_abort]]
[call [cmd ns_adp_break]]
[call [cmd ns_adp_exception]]
[call [cmd ns_adp_return]]
[list_end]

[def "ADP output commands"] 
[list_begin definitions]
[call [cmd ns_adp_append]]
[call [cmd ns_adp_puts]]
[call [cmd ns_adp_close]]
[call [cmd ns_adp_flush]]
[list_end]

[def "ADP introspection commands"] 
[list_begin definitions]
[call [cmd ns_adp_argc]]
[call [cmd ns_adp_argv]]
[call [cmd ns_adp_dir]]
[call [cmd ns_adp_dump]]
[call [cmd ns_adp_info]]
[call [cmd ns_adp_tell]]
[call [cmd ns_adp_stats]]
[list_end]

[call [cmd ns_adp_bind_args]]
[call [cmd ns_adp_debug]]
[call [cmd ns_adp_include]]
[call [cmd ns_adp_mimetype]]
[call [cmd ns_adp_parse]]
[call [cmd ns_adp_trunc]]
[list_end]

[section {Authorization Commands}]
[list_begin definitions]
[call [cmd ns_checkurl]]
[call [cmd ns_requestauthorize]]
[def "Module nsperm"]
[list_begin definitions]
[def [uri ../../nsperm/files/ns_perm.html ns_perm]]
[def [uri ../../nsperm/files/ns_perm.html ns_permreload]]
[def [uri ../../nsperm/files/ns_perm.html ns_permpasswd]]
[list_end]

[list_end]

[section {Cache Commands}]
[list_begin definitions]
[call [cmd ns_cache]]
[list_begin definitions]
[call [cmd ns_cache_flush]]
[call [cmd ns_cache_keys]]
[call [cmd ns_cache_names]]
[call [cmd ns_cache_stats]]
[call [cmd ns_cache_append]]
[call [cmd ns_cache_create]]
[call [cmd ns_cache_eval]]
[call [cmd ns_cache_incr]]
[call [cmd ns_cache_lappend]]
[call [cmd ns_fastpath_cache_stats]]
[list_end]

[call [cmd ns_memoize]]
[list_begin definitions]
[call [cmd ns_memoize_flush]]
[call [cmd ns_memoize_stats]]
[list_end]
[list_end]

[section {Cookie Commands}]
[list_begin definitions]
[call [cmd ns_cookie]]
[list_begin definitions]
[call [cmd ns_deletecookie]]
[call [cmd ns_getcookie]]
[call [cmd ns_setcookie]]
[list_end]
[list_end]

[section {Concurrent Programming, Job Administration}]
[list_begin definitions]
[call [cmd ns_cond]]
[call [cmd ns_critsec]]
[call [cmd ns_event]]
[call [cmd ns_job]]
[call [cmd ns_kill]]
[call [cmd ns_mutex]]
[call [cmd ns_rwlock]]
[call [cmd ns_sema]]
[call [cmd ns_sleep]]
[call [cmd ns_thread]]
[list_end]

[section {DNS Lookup Commands}]
[list_begin definitions]
[call [cmd ns_addrbyhost]]
[call [cmd ns_hostbyaddr]]
[list_end]

[section {Files and Filesystem Commands}]
[list_begin definitions]
[call [cmd ns_filestat]]
[call [cmd ns_ftruncate]]
[call [cmd ns_hashpath]]
[call [cmd ns_mktemp]]
[call [cmd ns_normalizepath]]
[call [cmd ns_rollfile]]
[call [cmd ns_symlink]]
[call [cmd ns_truncate]]
[list_end]

[section {Hashing and Encryption Commands}]
[list_begin definitions]
[call [cmd ns_certctl]]
[call [cmd ns_crypt]]
[call [cmd ns_crypto]]
[list_begin definitions]
[call [cmd ns_crypto::aead::encrypt]]
[call [cmd ns_crypto::aead::decrypt]]
[call [cmd ns_crypto::eckey]]
[call [cmd ns_crypto::hmac]]
[call [cmd ns_crypto::md]]
[call [cmd ns_crypto::randombytes]]
[call [cmd ns_crypto::scrypt]]
[list_end]
[call [cmd ns_hmac]]
[call [cmd ns_hash]]
[call [cmd ns_hotp]]
[call [cmd ns_md5]]
[call [cmd ns_md]]
[call [cmd ns_sha1]]
[call [cmd ns_totp]]
[list_end]


[section {HTML, Form, Request related Commands}]
[list_begin definitions]
[call [cmd ns_browsermatch]]
[call [cmd ns_conn]]
[call [cmd ns_connchan]]
[call [cmd ns_conncptofp]]
[call [cmd ns_formvalueput]]
[call [cmd ns_getcontent]]
[call [cmd ns_getform]]
[call [cmd ns_getformfile]]
[call [cmd ns_htmlselect]]
[call [cmd ns_internalredirect]]
[call [cmd ns_queryexists]]
[call [cmd ns_queryget]]
[call [cmd ns_querygetall]]
[call [cmd ns_return]]
[list_begin definitions]
[call [cmd ns_returnfile]]
[call [cmd ns_returnfp]]
[call [cmd ns_respond]]
[list_end]

[call [cmd returnstatus-cmds]]
[list_begin definitions]
[call [cmd ns_returnbadrequest]]
[call [cmd ns_returnerror]]
[call [cmd ns_returnforbidden]]
[call [cmd ns_returnmoved]]
[call [cmd ns_returnnotfound]]
[call [cmd ns_returnnotice]]
[call [cmd ns_returnok]]
[call [cmd ns_returnredirect]]
[call [cmd ns_returnunauthorized]]
[call [cmd ns_returnunavailable]]
[list_end]

[call [cmd ns_setexpires]]
[call [cmd ns_tagelement]]
[call [cmd ns_tagelementset]]
[call [cmd ns_writecontent]]
[call [cmd ns_writer]]
[list_end]

[section {HTTP and URL Commands}]
[list_begin definitions]
[call [cmd ns_absoluteurl]]
[call [cmd ns_http]]
[call [cmd ns_parsefieldvalue]]
[call [cmd ns_parseheader]]
[call [cmd ns_parsehostport]]
[call [cmd ns_parseurl]]
[call [cmd ns_url2file]]
[call [cmd ns_urldecode]]
[call [cmd ns_urlencode]]
[list_end]

[section {I18N - Internationalization Commands}]
[list_begin definitions]
[call [cmd ns_charsets]]
[call [cmd ns_choosecharset]]
[call [cmd ns_cookiecharset]]
[call [cmd ns_encodingforcharset]]
[call [cmd ns_encodingfortype]]
[call [cmd ns_formfieldcharset]]
[call [cmd ns_setformencoding]]
[call [cmd ns_strcoll]]
[call [cmd ns_urlcharset]]
[call [cmd ns_valid_utf8]]
[list_end]

[section {Image Processing}]
[list_begin definitions]
[call [cmd ns_gifsize]]
[call [cmd ns_jpegsize]]
[call [cmd ns_pngsize]]
[call [cmd ns_imgmime]]
[call [cmd ns_imgtype]]
[call [cmd ns_imgsize]]
[list_end]

[section {Logfile Management}]
[list_begin definitions]
[def "Module nslog"]
[list_begin definitions]
[def [uri ../../nslog/files/ns_accesslog.html ns_accesslog]]
[list_end]
[call [cmd ns_asynclogfile]]
[call [cmd ns_log]]
[list_begin definitions]
[call [cmd ns_logctl]]
[call [cmd ns_logroll]]
[list_end]
[list_end]

[section {Mail Commands}]
[list_begin definitions]
[call [cmd ns_sendmail]]
[call [cmd ns_sendmail_config]]
[list_end]

[section {MIME and Encoding-related Commands}]
[list_begin definitions]
[call [cmd ns_base64]]
[list_begin definitions]
[call [cmd ns_base64decode]]
[call [cmd ns_base64encode]]
[call [cmd ns_base64urldecode]]
[call [cmd ns_base64urlencode]]
[list_end]
[call [cmd ns_uudecode]]
[call [cmd ns_uuencode]]
[call [cmd ns_guesstype]]
[list_end]

[section {Scheduling Commands}]
[list_begin definitions]
[call [cmd ns_atclose]]
[call [cmd ns_atsignal]]
[list_begin definitions]
[call [cmd ns_atexit]]
[call [cmd ns_atprestartup]]
[call [cmd ns_atshutdown]]
[call [cmd ns_atstartup]]
[list_end]
[call [cmd ns_runonce]]
[call [cmd ns_schedule]]
[list_begin definitions]
[call [cmd ns_schedule_daily]]
[call [cmd ns_schedule_proc]]
[call [cmd ns_schedule_weekly]]
[call [cmd ns_unschedule_proc]]
[call [cmd ns_pause]]
[call [cmd ns_resume]]
[call [cmd ns_after]]
[list_end]
[list_end]

[section {Sharing Variables}]
[list_begin definitions]
[call [cmd nsv]]
[list_begin definitions]
[call [cmd {nsv_array}]]
[call [cmd {nsv_bucket}]]
[call [cmd {nsv_dict}]]
[call [cmd {nsv_exists}]]
[call [cmd {nsv_get}]]
[call [cmd {nsv_incr}]]
[call [cmd {nsv_append}]]
[call [cmd {nsv_lappend}]]
[call [cmd {nsv_names}]]
[call [cmd {nsv_set}]]
[call [cmd {nsv_unset}]]
[list_end]
[list_end]

[section {Streaming Commands}]
[list_begin definitions]
[call [cmd ns_write]]
[list_begin definitions]
[call [cmd ns_headers]]
[call [cmd ns_writefp]]
[list_end]
[list_end]



[section {Tcl Channel Management}]
[list_begin definitions]
[call [cmd ns_chan]]
[call [cmd ns_cleanupchans]]
[list_end]

[section {Time Commands}]
[list_begin definitions]
[call [cmd ns_fmttime]]
[call [cmd ns_gmtime]]
[call [cmd ns_httptime]]
[call [cmd ns_localtime]]
[call [cmd ns_parsehttptime]]
[call [cmd ns_parsetime]]
[call [cmd ns_time]]
[list_end]

[section {Registration of Filters and Procs for URLs}]
[list_begin definitions]
[call [cmd ns_register]]
[list_begin definitions]
[call [cmd ns_register_filter]]
[call [cmd ns_register_adp]]
[call [cmd ns_register_proc]]
[call [cmd ns_register_tcl]]
[call [cmd ns_register_trace]]
[call [cmd ns_unregister_op]]
[call [cmd ns_register_proxy]]
[call [cmd ns_register_fastpath]]
[call [cmd ns_register_fasturl2file]]
[call [cmd ns_register_url2file]]
[call [cmd ns_unregister_url2file]]
[list_end]
[call [cmd ns_shortcut_filter]]
[call [cmd ns_urlspace]]
[def "Module nscgi"]
[list_begin definitions]
[def [uri ../../nscgi/files/ns_register_cgi.html ns_register_cgi]]
[list_end]

[list_end]

[section {Tcl Interpreter Management Commands}]
[list_begin definitions]
[call [cmd ns_cleanup]]
[call [cmd ns_eval]]
[call [cmd ns_ictl]]
[call [cmd ns_init]]
[call [cmd ns_reinit]]
[list_end]

[section {Server Configuration Commands}]
[list_begin definitions]
[call [cmd ns_config]]
[list_begin definitions]
[call [cmd ns_configsection]]
[call [cmd ns_configsections]]
[call [cmd ns_section]]
[call [cmd ns_param]]
[list_end]
[call [cmd ns_library]]
[call [cmd ns_modulepath]]
[list_end]

[section {Server Introspection}]
[list_begin definitions]
[call [cmd ns_driver]]
[call [cmd ns_env]]
[call [cmd ns_info]]
[call [cmd ns_server]]
[list_end]

[section {Suicide Commands}]
[list_begin definitions]
[call [cmd ns_shutdown]]
[call [cmd ns_crash]]
[list_end]

[section {Socket Commands}]
[list_begin definitions]
[call [cmd ns_sls]]
[call [cmd ns_sockaccept]]
[call [cmd ns_sockblocking]]
[call [cmd ns_sockcallback]]
[call [cmd ns_sockcheck]]
[call [cmd ns_socketpair]]
[call [cmd ns_socklisten]]
[call [cmd ns_socklistencallback]]
[call [cmd ns_socknonblocking]]
[call [cmd ns_socknread]]
[call [cmd ns_sockopen]]
[call [cmd ns_sockselect]]
[list_end]

[section {Virtual Server Commands}]
[list_begin definitions]
[call [cmd ns_serverpath]]
[call [cmd ns_pagepath]]
[call [cmd ns_serverrootproc]]
[call [cmd ns_locationproc]]
[list_end]

[section {Data Structures}]
[list_begin definitions]
[call ns_set]
[list_begin definitions]
[call [cmd ns_set]]
[call [cmd ns_findset]]
[list_end]
[call [cmd keyl]]
[list_begin definitions]
[call [cmd keylget]]
[call [cmd keyldel]]
[call [cmd keylkeys]]
[call [cmd keylset]]
[list_end]
[list_end]

[section {Text Processing}]
[list_begin definitions]
[call [cmd textutil-cmds]]
[list_begin definitions]
[call [cmd ns_quotehtml]]
[call [cmd ns_reflow_text]]
[call [cmd ns_striphtml]]
[call [cmd ns_trim]]
[list_end]
[list_end]

[section {Operating System Interface and Systems Resource Limits}]
[list_begin definitions]
[call [cmd ns_setprivileges]]
[list_begin definitions]
[call [cmd ns_setgroup]]
[call [cmd ns_setuser]]
[list_end]
[call [cmd ns_rlimit]]
[list_end]

[section {Proxy Commands}]
[list_begin definitions]
[def "Module nsproxy"]
[list_begin definitions]
[def [uri ../../nsproxy/files/ns_proxy.html ns_proxy]]
[list_end]
[list_end]

[section {Generic Database Interface}]
[list_begin definitions]
[def "Module nsdb"]
[list_begin definitions]
[def [uri ../../nsdb/files/ns_buildsqldate.html ns_buildsqldate]]
[def [uri ../../nsdb/files/ns_buildsqldate.html ns_localsqltimestamp]]
[def [uri ../../nsdb/files/ns_db.html ns_db]]
[def [uri ../../nsdb/files/ns_dbquotevalues.html ns_dbquotelist]]
[def [uri ../../nsdb/files/ns_dbquotevalues.html ns_dbquotelist]]
[def [uri ../../nsdb/files/ns_dbquotevalues.html ns_dbquotename]]
[def [uri ../../nsdb/files/ns_dbquotevalues.html ns_dbquotevalue]]
[def [uri ../../nsdb/files/ns_getcsv.html ns_getcsv]]
[list_end]
[list_end]

[section {Access Log}]
[list_begin definitions]
[list_end]

[section {Unsorted}]
[list_begin definitions]
[call [cmd ns_rand]]
[call [cmd ns_tcl_abort]]
[call [cmd ns_set_precision]]
[call [cmd ns_hrefs]]
[call [cmd ns_issmallint]]
[call [cmd ns_module]]
[call [cmd ns_openexcl]]
[call [cmd ns_paren]]
[call [cmd ns_parseargs]]
[call [cmd ns_parsequery]]
[call [cmd ns_purgefiles]]
[call [cmd ns_filewrite]]
[call [cmd ns_sourcefile]]
[call [cmd ns_proxy_handler_http]]
[call [cmd ns_fileread]]
[call [cmd ns_sourceproc]]
[call [cmd ns_upload_stats]]
[call [cmd ns_moduleload]]
[call [cmd ns_baseunit]]
[list_end]

[section {Deprecated}]
[list_begin definitions]
[call [cmd "env"]]                  Use [cmd "ns_env"] instead.
[call [cmd "ns_adp_compress"]]      Use [cmd "ns_conn compress"] instead.
[call [cmd "ns_adp_eval"]]          Use [cmd "ns_adp_parse"] instead.
[call [cmd "ns_adp_mime"]]          Use [cmd "ns_adp_mimetype"] instead.
[call [cmd "ns_adp_registertag"]]   Use [cmd "ns_adp_registeradp"] instead.
[call [cmd "ns_adp_safeeval"]]      Use [cmd "ns_adp_parse -safe"] instead.
[call [cmd "ns_adp_stream"]]        Use [cmd "ns_adp_ctl stream"] instead.
[call [cmd "ns_cancel"]]            Use [cmd "ns_unschedule_proc"] instead.
[call [cmd "ns_chmod"]]             Use [cmd "file attributes"] instead.
[call [cmd "ns_connsendfp"]]        Use [cmd "ns_writefp"] instead.
[call [cmd "ns_cp"]]                Use [cmd "file copy"] instead.
[call [cmd "ns_cpfp"]]              Use [cmd "fcopy"] instead.
[call [cmd "ns_getchannels"]]       Use [cmd "file channels"] instead.
[call [cmd "ns_geturl"]]            Use [cmd "ns_http"] instead.
[call [cmd "ns_hmac_sha2"]]         Use [cmd "ns_crypto::hmac string"] instead.
[call [cmd "ns_httpget"]]           Use [cmd "ns_http"] instead.
[call [cmd "ns_httpopen"]]          Use [cmd "ns_http"] instead.
[call [cmd "ns_httppost"]]          Use [cmd "ns_http"] instead.
[call [cmd "ns_info filters"]]      Use [cmd "ns_server filters"] instead.
[call [cmd "ns_info pagedir"]]      Use [cmd "ns_server pagedir"] instead.
[call [cmd "ns_info pageroot"]]     Use [cmd "ns_server pagedir"] instead.
[call [cmd "ns_info platform"]]     Use [cmd "$::tcl_platform(platform)"] instead.
[call [cmd "ns_info requestprocs"]] Use [cmd "ns_server requestprocs"] instead.
[call [cmd "ns_info tcllib"]]       Use [cmd "ns_server tcllib"] instead.
[call [cmd "ns_info traces"]]       Use [cmd "ns_server traces"] instead.
[call [cmd "ns_info url2file"]]     Use [cmd "ns_server url2file"] instead.
[call [cmd "ns_info winnt"]]        Use [cmd "$::tcl_platform(platform)"] instead.
[call [cmd "ns_isformcached"]]      Obsolete.
[call [cmd "ns_link"]]              Use [cmd "file link -hard ..."] instead.
[call [cmd "ns_mkdir"]]             Use [cmd "file mkdir"] instead.
[call [cmd "ns_passwordcheck"]]     Use [cmd "ns_perm checkpass"] instead.
[call [cmd "ns_puts"]]              Use [cmd "ns_adp_puts"] instead.
[call [cmd "ns_register_adptag"]]   Use [cmd "ns_adp_registerscript"] instead.
[call [cmd "ns_rename"]]            Use [cmd "file rename"] instead.
[call [cmd "ns_resetcachedform"]]   Obsolete.
[call [cmd "ns_returnadminnotice"]] Use [cmd "ns_returnnotice"] instead.
[call [cmd "ns_rmdir"]]             Use [cmd "file delete"] instead.
[call [cmd "ns_server keepalive"]]  Use [cmd "ns_conn keepalive"] instead.
[call [cmd "ns_sha2"]]              Use [cmd "ns_crypto::md string"] instead.
[call [cmd "ns_startcontent"]]      Use [cmd "ns_headers"] instead.
[call [cmd "ns_thread create"]]     Use [cmd "ns_thread begin"] instead.
[call [cmd "ns_thread get"]]        Use [cmd "ns_thread handle"] instead.
[call [cmd "ns_thread getid"]]      Use [cmd "ns_thread id"] instead.
[call [cmd "ns_thread join"]]       Use [cmd "ns_thread wait"] instead.
[call [cmd "ns_tmpnam"]]            Use [cmd "ns_mktemp"] instead.
[call [cmd "ns_unlink"]]            Use [cmd "file delete"] instead.
[call [cmd "ns_unregister_proc"]]   Use [cmd "ns_unregister_op"] instead.
[call [cmd "ns_updateheader"]]      Use [cmd "ns_set update"] [lb]ns_conn outputheaders[rb] instead.
[call [cmd "ns_var"]]               Use [cmd "nsv_*"] instead.
[list_end]

[see_also nsd]
[keywords NaviServer]
[manpage_end]
