[include version_include.man]
[manpage_begin ns_adp_bind_args n [vset version]]
[moddesc {NaviServer Built-in Commands}]

[titledesc {Bind ADP arguments to variables}]

[description]

 This command assigns the ADP arguments from the current ADP frame to variables
 specified in one or more varName parameters.  There must be an equal number
 of varName arguments as there are ADP arguments, otherwise an error will
 be thrown.

 Note that the first varName is not assigned the name of the ADP.  In other
 words, varName starts from index 1 in the ns_adp_argv list.

[section {COMMANDS}]

[list_begin definitions]

[call [cmd ns_adp_bind_args] [arg varName] [opt [arg {varName ...}]]]

[list_end]


[section EXAMPLES]

[example_begin]
 # In a.adp:
 <% ns_adp_include b.adp 1 2 3 %>
[example_end]

[example_begin]
 # In b.adp:
 <%
   ns_adp_bind_args x y z
   list $x $y $z       ;# => {1 2 3}
 %>
[example_end]


[see_also ns_adp_include ns_adp_parse ns_adp_argc ns_adp_argv nsd]
[keywords "server built-in" ADP]

[manpage_end]

