[include version_include.man]
[include version_include.man]

[manpage_begin ns_atsignal n [vset version]]
[moddesc   {NaviServer Built-In Commands}]
[titledesc {Server callbacks}]


[description]

These commands provide hooks for you to register your own procedures to
be called during the different stages of the server processes lifetime.

[para]
You can find out which callbacks are already registered with the
[cmd "ns_info callbacks"] command. Further callbacks can be registered
via [cmd "ns_ictl trace"].


[section {COMMANDS}]

[list_begin definitions]

[call [cmd ns_atprestartup] \
 [arg script] \
 [opt [arg args]]  ]

Pre-startup procs are called in FIFO order after the configuration file has been
parsed and all modules loaded, but before the driver starts listening for and
processing connections.



[call [cmd ns_atstartup] \
 [arg script] \
 [opt [arg args]]  ]

Startup procs are called in FIFO order just after the server is fully
initialized and is listening for and processing connections.



[call [cmd ns_atsignal] \
 [arg script] \
 [opt [arg args]]  ]

Signal procs are called in FIFO order whenever a [term HUP] signal is received
by the server process.

[para] The following example shows how to log the accumulated cache
statistics and reset whenever the server is signaled.

[example_begin]
 [cmd ns_atsignal] {
   foreach cache [lb]ns_cache_names[rb] {
      ns_log notice "cache\[lb]$cache\[rb]: [lb]ns_cache_stats -reset -- $cache[rb]"
   }
 }
[example_end]


[call [cmd ns_atshutdown] \
 [arg script] \
 [opt [arg args]]  ]

At-shutdown procs are called in LIFO order when the server performs a controlled
shutdown after all other subsystem have been stopped.

[para]
Orderly shutdown is attempted within [term shutdowntimeout], as
specified in the configuration file. Tcl shutdown procs are called before C
shutdown tasks are waited on, so should be well-behaved.

[para] Do not attempt to use other subsystems for shutdown jobs, such
as the [cmd ns_job] command.



[call [cmd ns_atexit] \
 [arg script] \
 [opt [arg args]]  ]

At-exit procs are called in LIFO order after all [term shutdown] procs have been
called and the server process is ready to exit.  The [term atexit] procs are
basically the last code to run.



[list_end]


[see_also ns_info ns_atclose ns_ictl ns_runonce]
[keywords "global built-in" signal startup shutdown exit callback]

[manpage_end]
