[include version_include.man]
[manpage_begin ns_crypt n [vset version]]
[moddesc {NaviServer Built-in Commands}]

[titledesc {Encrypt a string for use as a password}]

[description]

This command encrypts the key using the salt and returns the encrypted string. 
It uses the same algorithm as the Unix crypt command.

Normally, key is a password, of which the first 8 bytes are significant,
and salt is one or two bytes used to encrypt the key.  The string returned
should always be 13 characters long and is usable as the password field in
nscp and nsperm authentication.

The algorithm used is a one-way cipher, which means that the original plain-text
key cannot be derived knowing the encrypted string alone.  However, since only 
up to the first 8 bytes of key are significant, only a 64-bit key is effectively used, 
which is reasonably attacked with modern computers with ordinary brute-force attacks today.

[section {COMMANDS}]

[list_begin definitions]

[call [cmd ns_crypt] [arg key] [arg salt]]

[list_end]


[section EXAMPLES]

[example_begin]
 % ns_crypt password qy
 qyz8eIFW3uJoo
[example_end]


[see_also nsd ns_base64 ns_md ns_hmac ns_sha1 ns_md5]
[keywords "global built-in" encoding crypto]

[manpage_end]

