[include version_include.man]
[manpage_begin ns_driver n [vset version]]
[moddesc {NaviServer Built-in Commands}]

[titledesc {Obtain Network Driver Information.}]

[description] The command [cmd ns_driver] allows one to obtain information
 about the loaded drivers, their configuration and their usage.

[para] In general, one NaviServer process might have multiple driver
modules loaded. Every driver module has a type (such as e.g. "nssock"
for HTTP connections or "nsssl" for HTTPS) and a name, where the type
of the driver module is often used for its name as well. However, when
a driver module of a certain type is loaded multiple times
(e.g. listening at different addresses or ports) every driver module
instance must have a distinct name.

[para]
Consult the
[uri ../../manual/files/admin-config.html "NaviServer Configuration Reference"]
and the documentation of the
[uri ../../nssock/files/nssock.html "nssock network driver"]
for detailed configuration options of the network drivers.

[section {COMMANDS}]

[list_begin definitions]
[call [cmd "ns_driver info"]]

 The command [cmd "ns_driver info"] returns a list of lists containing
 driver information. Every outer list element describes a different
 driver module instance. For every driver module instance the
 following information elements are returned:

[list_begin itemized]
[item] [term module] refers to the name of the driver module, such as
e.g. "nssock"
[item] [term type] refers to the type of the driver module, such as
e.g. "nssock"
[item] [term server] is the associated server, if this module is
loaded for a certain server; for global drivers, the value is empty.
[item] [term location] is the location as derived from the
configuration data, might be e.g. "http://localhost:8091"
[item] [term address] is the space separated list of IP addresses
(IPv4 or IPv6), on which the driver is listening, might be e.g. "0.0.0.0"
[item] [term port] space separated list of ports, on which the driver listens
[item] [term defaultport] the default port for this driver
[item] [term protocol] is the name of the protocol, such as e.g. "http"
[item] [term sendwait] timeout for send operations.
[item] [term recvwait] timeout for receive operations.
[item] [term extraheaders] are the extra response header fields to be returned
on every request via this driver.
[item] [term libraryversion] version number of the library implemented
major parts of the communication.
[list_end]


[call [cmd "ns_driver names"] ]

 Return a list of the names of the loaded driver modules.

[call [cmd "ns_driver threads"] ]

Return a list of the names of the driver threads

[call [cmd "ns_driver stats"] ]

Return for every driver thread the name of the driver module, the
number of received requests, the number of spooled requests, the
partial requests (received via multiple receive operations), and the
number of errors.

[list_end]

[see_also ns_info ns_server ]
[keywords "server built-in" address nssock socket driver configuration SO_REUSEPORT]

[manpage_end]


