[include version_include.man]
[manpage_begin ns_fmttime n [vset version]]
[moddesc {NaviServer Built-in Commands}]

[titledesc {Convert seconds to a human-readable format using templates}]

[description]

This command produces a string representation of time in seconds since 00:00:00 UTC Jan 1, 1970.

[para]
[cmd ns_fmttime] uses the [term strftime()] system call, so valid
format strings will vary from platform 
to platform.  Consult your operating system's documentation for [term strftime()] to see what 
valid fmt strings can contain.  [term fmt] defaults to "%c" which is supposed to be the preferred
date and time representation for the current locale, which on some platforms should be 
"%a %b %e %H:%M:%S %Z %Y".


[section {COMMANDS}]

[list_begin definitions]


[call [cmd ns_fmttime] [arg time] [opt [arg fmt]]]


[list_end]

[section EXAMPLES]

[example_begin]
 % ns_fmttime 0
 Wed Dec 31 19:00:00 1969
[example_end]

[example_begin]
 % ns_fmttime 0 "%a %b %e %H:%M:%S %Z %Y"
 Wed Dec 31 19:00:00 EST 1969
[example_end]

[example_begin]
 % ns_fmttime ns_time "%Y%m%d"
 20040614
[example_end]


[keywords "global built-in" time]
[see_also ns_gmtime ns_httptime ns_localtime ns_parsehttptime ns_parsetime ns_time]


[manpage_end]

