[include version_include.man]
[manpage_begin ns_getformfile n [vset version]]
[moddesc {NaviServer Built-in Commands}]

[titledesc {Return a tempfile for a form file field}]

[description]

[section COMMANDs]

[list_begin definitions]

[call [cmd ns_getformfile] [arg name]]

return the path of the temporary file uploaded via an HTML input field
named [arg name], or empty when no such file was submitted. When the
input element of the file contains the HTML5 attribute [term multiple],
a list of filenames is potentially returned.

[list_end]

For example, when the HTML page contains a form like the following

[example_begin]
 <form enctype="multipart/form-data" action="url" method="post">
 First file: <input name="file1" type="file">
 Second file: <input name="file2" type="file">
 <input type="submit">
 </form>
[example_end]

and the form is submitted, the server access the submitted files
[term file1] and [term file2] via the following snippet

[example_begin]
 set tmpfile1 [lb]ns_getformfile file1[rb]
 set tmpfile2 [lb]ns_getformfile file2[rb]
 set fp1 [lb]open $tmpfile1[rb]
 ...
[example_end]

[manpage_end]
