[include version_include.man]
[manpage_begin ns_gmtime n [vset version]]
[moddesc {NaviServer Built-in Commands}]

[titledesc {Return current time in Greenwich Mean Time (GMT)}]

[description]
This command returns a nine-element Tcl list representing the current time in Greenwich Mean
Time (GMT).

[section {COMMANDS}]

[list_begin definitions]

[call [cmd ns_gmtime]]

[para] The structure of the returned list corresponds to the Unix struct tm time structure:
[list_begin itemized]
[item] seconds]
[item] minutes (0-59)
[item] hours (0-23)
[item] dayofmonth (1-31)
[item] monthofyear (0-11)
[item] year (year-1900)
[item] dayofweek (0-6, Sunday=0)
[item] dayofyear (0-365)
[item] isdst (>0 if Daylight Savings Time is in effect)
[list_end]

[list_end]


[section EXAMPLES]

[example_begin]
 % ns_gmtime
 40 31 2 12 5 104 6 163 0
[example_end]


[keywords "global built-in" time]
[see_also ns_fmttime ns_httptime ns_localtime ns_parsehttptime ns_parsetime ns_time]

[manpage_end]

