[include version_include.man]
[manpage_begin ns_md5 n [vset version]]
[moddesc {NaviServer Built-in Commands}]

[titledesc {Returns a 32-character, hex-encoded string containing the MD5 hash of the first argument}]

[description]
A cryptographic hash (sometimes called digest) is a kind of signature for a text or a data file.
MD5 generates an almost-unique 128-bit signature for a text.

[section {COMMANDS}]

[list_begin definitions]

[call [cmd ns_md5] \
	[opt [option -binary]] \
	[opt [option --]] \
	[arg string]]

[para]

Compute an MD5 checksum from the provided [arg string]
When the option [option -binary] is used, the Tcl byte array value
of the provided input argument is used and no UTF-8 interpretation
is performed.

[list_end]

[example_begin]
 nscp 2> ns_md5 test   
 098F6BCD4621D373CADE4E832627B4F6
[example_end]

[see_also nsd ns_md ns_base64 ns_crypt ns_sha1 ns_rand ns_hmac]
[keywords "global built-in" encoding crypto]

[manpage_end]


