[include version_include.man]
[manpage_begin ns_parseheader n [vset version]]
[moddesc {NaviServer Built-in Commands}]

[titledesc {Parse HTTP header}]

[description]
This function parses a single HTTP header line into a predefined
[cmd ns_set] specified by [arg set].


[section {COMMANDS}]

[list_begin definitions]

[call [cmd ns_parseheader] \
        [opt [option -prefix]] \
        [arg set] [arg headerline] \
        [opt [arg disposition]] ]

[para] The [arg headerline] specifies a line containing HTTP
header fields, where the field name is parased into a key of the
[cmd ns_set] and the field value to the value of the entry.

[para]
The option [option -prefix] can be used to specify a prefix for the
key.

[para]
Optional argument [arg disposition] can be one of the following
[list_begin itemized]
    [item] toupper - convert header names to uppercase
    [item] tolower - convert header names to lowercase
    [item] preserve - preserve the existing case
[list_end]
When no [arg disposition] is provided, it defaults to [term tolower]

[list_end]

[section EXAMPLES]

[example_begin]
 set reply [lb]ns_set create reply[rb]
 ns_parseheader $reply "Connection: Upgrade"
 
 #
 # Return the content of the ns_set in form of a dict
 #
 ns_set array $reply
 % connection Upgrade
[example_end]


[see_also nsd ns_parseurl ns_parsefieldvalue]
[keywords "global built-in" NaviServer parse]
[manpage_end]


