[include version_include.man]
[manpage_begin ns_parsequery n [vset version]]
[moddesc {NaviServer Built-in Commands}]

[titledesc {Parse a URL query string into an ns_set}]

[description]

Parse HTTP query parameters.

[section {COMMANDS}]

[list_begin definitions]

 [call [cmd ns_parsequery] \
     [opt [option "-charset [arg charset]"]] \
     [opt [option "-fallbackcharset [arg fallbackcharset]"]] \
     [opt [arg "--"]] \
     [arg querystring]]

[list_end]

This command parses the specified HTTP [arg querystring] into an
[cmd ns_set], which is returned.  The keys and values will be decoded based
by the rules used for [cmd ns_urlencode]. In case the query cannot be
parsed to the charset, an exception is raised (with exception code
NS_INVALID_UTF8).

[para]
The option [option -charset] can be used to specify the character set of
the encode operation.

[para]

The option [option -fallbackcharset] can be used to specify an
alternative character set when the conversion of the
[arg querystring] leads to invalid UTF-8. Instead of raising an exception,
a second attempt of decoding the query string is made with the fallback
charset. Note that the fallback charset can be provided as well via the
configuration parameter [term formfallbackcharset]. For more details,
see [cmd ns_getform].

[section EXAMPLES]

[example_begin]
 % set s [lb]ns_parsequery "msg=Hello+World%21&a=b&a=b&c=d"[rb]
 d0
 
 % ns_set array $s
 msg {Hello World!} a b a b c d
[example_end]


[para]

[see_also ns_set ns_getform ns_urlencode ns_parseurl]
[keywords "global built-in" URL query encoding charset urlcharset formfallbackcharset]

[manpage_end]
