[include version_include.man]
[manpage_begin ns_sha1 n [vset version]]
[moddesc {NaviServer Built-in Commands}]

[titledesc {Returns a 40-character, hex-encoded string containing the SHA1 hash of the first argument}]

[description]
A cryptographic hash (sometimes called digest) is a kind of signature for a text or a data file.
SHA1 generates an almost-unique 160-bit signature for a text.

[section {COMMANDS}]

[list_begin definitions]

[call [cmd ns_sha1] \
	[opt [option -binary]] \
	[opt [option --]] \
	[arg string]]

[para]
Compute an SHA1 checksum from the provided [arg string].
When the option [option -binary] is used, the Tcl byte array value
of the provided input argument is used and no UTF-8 interpretation
is performed.

[list_end]

[example_begin]
   nscp 2> ns_sha1 test   
   A94A8FE5CCB19BA61C4C0873D391E987982FBBD3
[example_end]

[see_also nsd ns_md ns_base64 ns_crypt ns_md5 ns_rand ns_hmac]
[keywords "global built-in" encoding crypto]

[manpage_end]


