[include version_include.man]
[manpage_begin ns_shutdown n [vset version]]
[moddesc {NaviServer Built-in Commands}]

[titledesc {Shut down NaviServer}]

[description]

This command shuts down the server, optionally waiting [arg timeout]
seconds to let existing connections and background jobs finish.  When 
this time limit is exceeded the server shuts down immediately.

[para] When [arg timeout] is not specified the default or configured
[arg timeout] is used (default 20). The default can be changed by the
parameter [term shutdowntimeout] in the global server parameters
(section [term ns/parameters] in the configuration file). When [arg timeout]
it is specified, it must be a value >= 0.

[section {COMMANDS}]

[list_begin definitions]

[call [cmd ns_shutdown] \
	[opt [option -restart]] \
	[opt [arg timeout]]]

[para]
[arg timeout]
Time to wait before shutting down the server.
The [arg timeout] can be specified in the form
[arg secs[opt :microsecs]], or [arg secs.fraction],
or as a number with a time unit.

[para]
[option -restart]
send an interrupt signal to the server, leading to a nonzero exit code.

[list_end]

[section EXAMPLES]

[example_begin]
 ns_shutdown
 ns_shutdown 30s
[example_end]

[see_also ns_kill ns_time]
[keywords "server built-in" restart]

[manpage_end]

