[include version_include.man]
[manpage_begin ns_sockopen n [vset version]]
[moddesc {NaviServer Built-in Commands}]

[titledesc {Connect to a remote host on the specified port}]

[description]
[cmd ns_sockopen] uses socket(), bind(), and connect() calls to connect to the
remote host (host) on the specified port (port). [cmd  ns_sockopen] returns a
list of two file ids: the first one for reads and the second one for writes.

[para]

The [option -nonblock] option specifies that the command will return immediately,
while the connect is still in progress by the operating system. If you
use [option -nonblock], you then can call [cmd ns_sockcheck] with the write file id to
see if the connect was actually completed.

[para]
The [option "-timeout [arg t]"] option specifies how long to wait for the
connect to be made.
The value [arg t] can be specified in the form
[arg secs[opt :microsecs]], or [arg secs.fraction],
or as a number with a time unit.

[section {COMMANDS}]

[list_begin definitions]

[call [cmd ns_sockopen] [opt [option -nonblock]] [opt [option -timeout]] [arg host] [arg port]]

[list_end]

[section EXAMPLES]

[example_begin]
 set fds [lb]ns_sockopen www.aolserver.com 80[rb]
 set rid [lb]lindex $fds 0[rb]
 set wid [lb]lindex $fds 1[rb]
 puts $wid "GET /index.htm HTTP/1.0\r\n\r"
 flush $wid
 while {[lb]set line [lb]string trim [lb]gets $rid[rb][rb][rb] != ""} {
  lappend headers $line
 }
 set page [lb]read $rid[rb]
 close $rid
 close $wid
[example_end]


[see_also ns_sockcallback ns_sockcheck ns_time]
[keywords "global built-in" NaviServer socket]
[manpage_end]
