[include version_include.man]
[manpage_begin ns_time n [vset version]]
[moddesc {NaviServer Built-in Commands}]

[titledesc {Perform various time-related functions}]

[description]

This command provides various time-related functions.
Times might be of the form "sec" (integer value),
"sec:usec" (NaviServer internal format) or "sec.fraction"

[para]
All [arg "time"] arguments
can be specified in the form
[arg secs[opt :microsecs]], or [arg secs.fraction],
or as a number with a time unit. Valid time units are
μs, ms, s, m, h, d, w, y.

[section {COMMANDS}]

[list_begin definitions]

[call [cmd ns_time] [opt [arg {arg arg ...}]]]

[list_end]

[list_begin definitions]

[call [cmd  {ns_time}]]

Returns the seconds portion of the current time.

[call [cmd  {ns_time adjust}] [arg time]]

Adjusts time so that it is within the valid range of values for a time.
(TODO:  Figure out how this is actually useful.)

[call [cmd  {ns_time diff}] [arg time1] [arg time2]]

Computes the time difference between time1 to time2.  It does this
by subtracting time1 from time2 and returns a string in "sec:usec" format.

[call [cmd  {ns_time format}] [arg time]]

Returns the [arg time] in seconds in the form of a real number.

[call [cmd  {ns_time get}]]

Returns the current time in "sec:usec" format.


[call [cmd  {ns_time  incr}] [arg time] [arg sec] [opt [arg usec]]]

Increments time by sec seconds and optionally usec microseconds.
Returns a string in "sec:usec" format.


[call [cmd  {ns_time make}] [arg sec] [opt [arg usec]]]

Returns a string in the form "sec:usec".  [term usec] defaults to zero.
If [term usec] is zero, the colon and usec are not returned.
If [term sec] is zero, however, it is returned as part of the time string.


[call [cmd  {ns_time seconds}] [arg time]]

Parses a time and returns the seconds portion.


[call [cmd  {ns_time microseconds}] [arg time]]

Parses a time and returns the microseconds portion.
It assumes zero microseconds if time only contains seconds.

[list_end]

[section EXAMPLES]

[example_begin]
 % ns_time
 1087006685
[example_end]

[example_begin]
 % ns_time get
 1087013247:598897
[example_end]

[example_begin]
 % set t [lb]ns_time diff $time $time3[rb]
 0:13
 
 % ns_time format $t
 0.000013
[example_end]


[keywords "global built-in" time timeunit]
[see_also ns_fmttime ns_gmtime ns_httptime ns_localtime ns_parsehttptime ns_parsetime ns_sleep]

[manpage_end]


