[include version_include.man]
[manpage_begin ns_valid_utf8 n [vset version]]
[moddesc {NaviServer Built-in Commands}]

[titledesc {Check whether the provided byte-array contains a valid UTF-8 byte sequence}]

[description]

[section {COMMANDS}]

[list_begin definitions]

[call [cmd ns_valid_utf8] \
        [arg string] \
        [opt [arg varname]] \
        ]

[para] This function checks whether the provided argument (a Tcl
byte-array) contains a valid UTF-8 code). The function returns a
boolean result. When the optional [arg varname] is specified,
a variable with this name is set in failure cases to the
invalid part of the input [arg string].

[para] Note that this function
only makes sense when applied on binary data, typically read from a
socket or a file.

[example_begin]
 % ns_valid_utf8 [encoding convertto utf-8 motörhead]
 1
 
 % ns_valid_utf8 "foo\x85"
 0
 
 % ns_valid_utf8 mot\x85rhead errorString
 0
 % set errorString
 mot|\x85r|...
[example_end]

[list_end]

[keywords "global built-in" parse utf-8 encoding i18n]
[manpage_end]


